local file = {priority = 0}

Animation = {}

function Animation:new(img, playTime, frames)
	local self = Class:init(Animation, Dynamic)
	if type(img) == "string" then
		img = lg.newImage(img)
	end
	self.img = img
	self.playTime = playTime
	self.timer = 0
	self.nrOfFrames = img:getWidth() / img:getHeight()
	self.frames = frames or {}
	self.looping = true

	local w = self.img:getHeight()
	if #self.frames == 0 then
		local canvas_default = lg.getCanvas()
		lg.setColor(1,1,1)
		for i = 1, self.nrOfFrames do
			self.frames[i] = lg.newCanvas(w,w)
			lg.setCanvas(self.frames[i])
			lg.draw(self.img,-(i-1)*w,0)
		end
		lg.setCanvas(canvas_default)
	end

	return self
end


function Animation:update()
	self.timer = (self.timer + gdt / self.playTime)
	if self.looping then
		self.timer = self.timer % 1
	else
		self.timer = min(0.99999,self.timer)
	end
end

function Animation:getFrame()
	return self.frames[floor(self.timer * self.nrOfFrames) + 1]
end

function Animation:clone(randomOffset)
	local copy = Animation:new(self.img,self.playTime,self.frames)
	if randomOffset then
		copy.timer = random()*copy.playTime
	end
	return copy
end

function Animation:setTimer(timer)
	self.timer = timer or 0
end



function file:init()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file