local file = {priority = 1}

Array = {}

function Array:new(dim,defaultValue)
	local self = Class:init(Array)

	self.dim = dim
	self.width = self.dim[1]
	self.height = self.dim[2]

	self.array = {}
	for x=1,dim[1] do
		self.array[x] = {}
		for y=1,dim[2] do
			self.array[x][y] = defaultValue or false
		end
	end

	return self
end


function Array:get(pos,y)
	if type(pos) == "number" then
		pos = {pos,y}
	end

	local x = floor(max(1,min(pos[1],self.dim[1])))
	local y = floor(max(1,min(pos[2],self.dim[2])))
	return self.array[x][y]
end

function Array:set(value,pos)
	if pos[1] >= 1 and pos[1] <= self.dim[1] and pos[2] >= 1 and pos[2] <= self.dim[1] then
		self.array[pos[1]][pos[2]] = value
	end
end

function Array:fill(value,runFunc,args)
	runFunc = runFunc or true
	local valueType = type(value)
	for x=1,self.dim[1] do
		for y=1,self.dim[2] do
			if valueType == "function" and runFunc then
				self.array[x][y] = value({x,y},args)
			else
				self.array[x][y] = value
			end
		end
	end
end

function file:init()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file