local file = {priority = -10}

Camera = {}

function Camera:new(pos)
	local self = Class:init(Camera,Entity,{pos})
	
	self.chasePos = self.pos
	self.chaseSpeed = 5
	self.zoom = 1
	self.tilt = 0
	self.order = -10

	return self
end


function Camera:setPos(pos)
	Entity.setPos(self, pos)
end

function Camera:setChasePos(pos)
	self.chasePos = pos
end

function Camera:chase()
	local dist = math.dist(self.pos[1],self.pos[2], self.chasePos[1],self.chasePos[2])
	local ang = math.angle(self.pos[1],self.pos[2], self.chasePos[1],self.chasePos[2])

	if dist < 0.3 then
		self:setPos(self.chasePos)
	end

	self:move(cos(ang)*dist*self.chaseSpeed*gdt, sin(ang)*dist*self.chaseSpeed*gdt)
end

function Camera:update()
	self:chase()
end


function Camera:apply()
	local juiceX,juiceY = Juice:getOffset()
	local juiceScale = Juice:getScale()
	local juiceTilt = Juice:getRotation()

	lg.translate(Screen.resolution[1]*0.5 + floor(juiceX+0.5),Screen.resolution[2]*0.5 + floor(juiceY+0.5))
	lg.scale(self.zoom * juiceScale)
	lg.rotate(self.tilt + juiceTilt)

	local x,y = floor(self.pos[1]*self.zoom)/self.zoom,floor(self.pos[2]*self.zoom)/self.zoom
	lg.translate(-x,-y)
end

function Camera:draw()
	self:apply()
end


function file:init()
	Camera = Camera:new({0,0})
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file