local file = {priority = 1}

Checkpoint = {list = {}}

function Checkpoint:new(pos)
	local self = Class:init(Checkpoint,Entity,{pos})

	self.sprite = Sprite:new(self.pos,lg.newImage("assets/level/checkpoint.png"))
	self.sprite:setParent(self)
	self.active = false

	self.torchSound = la.newSource("assets/audio/torch.wav","static")
	self.healSound = la.newSource("assets/audio/heal.wav","static")

	self.pTimer = 0

	self.sprite.order = 0.96

	table.insert(Checkpoint.list,self)

	return self
end




function Checkpoint:update()
	local pos = {self.pos[1]+random()*rsign(),self.pos[2]-10+random()*rsign()}

	if self:dist(Player) < 10 then
		if not self.active then
			Utils.playSound(self.torchSound)
		end
		if Player.health < Player.maxHealth then
			Utils.playSound(self.healSound)
			for a = 0,rad(360),rad(5) do
				Particle:new(pos,3,{5.5/8,5.5/8,5.5/8},0.5,0,{cos(a)*20,sin(a)*20})
			end
		end
		for i, c in pairs(Checkpoint.list) do
			c.active = false
		end
		self.active = true
		Player.respawnPoint = self.pos
		Player.health = Player.maxHealth
	end

	if self.active then
		self.pTimer = self.pTimer + gdt
		if self.pTimer > 0.05 then
			local p = Particle:new(pos,3,{5.5/8,5.5/8,5.5/8},0.5,0,{0,-50})
			p.order = 0.97
		end
	end
end


function Checkpoint:destroy()
	Entity.destroy(self)
end

function file:init()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file