local file = {priority = 1}

Corpse = {list = {}}

function Corpse:new(img, pos, dir, flip)
	local self = Class:init(Corpse,Entity,{pos})

	self.sprite = Sprite:new(self.pos, img)
	self.sprite.color = {0.8,0.8,0.8}
	self.sprite.oy = 0.5
	self.sprite:setParent(self)

	self.gravity = 350
	self.rotSpeed = rad(720)*flip + random()*rsign()*rad(200)

	self.dir = dir or {0,0}

	table.insert(Corpse.list,self)
	return self
end


function Corpse:moveAround()
	self:move(self.dir[1]*gdt,self.dir[2]*gdt)
	self.dir[2] = self.dir[2] + self.gravity*gdt
	self.sprite.rot = self.sprite.rot + self.rotSpeed * gdt
end


function Corpse:update()
	self:moveAround()
end


function Corpse:destroy()
	Entity.destroy(self)
	self.sprite:destroy()
	removeFromTable(Corpse.list,self)
end

function file:init()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file