local file = {priority = 0}

Entity = {list = {}}

function Entity:new(pos)
	local self = Class:init(Entity,Dynamic)

	self.pos = pos or {0,0}
	self.prevPos = self.pos

	table.insert(Entity.list,self)
	return self
end


function Entity:onScreen()
	return self.pos[1] > Camera.pos[1] - Screen.resolution[1]*0.5 and
	self.pos[1] < Camera.pos[1] + Screen.resolution[1]*0.5 and
	self.pos[2] > Camera.pos[2] - Screen.resolution[2]*0.5 and
	self.pos[2] < Camera.pos[2] + Screen.resolution[2]*0.5
end

function Entity:setPos(pos)
	self.prevPos = {self.pos[1],self.pos[2]}
	self.pos = pos
end

function Entity:move(offset,y)
	if type(offset) == "number" then
		offset = {offset,y}
	end
	self:setPos({self.pos[1]+offset[1], self.pos[2]+offset[2]})
end

function Entity:setParent(parent,offset,floored)
	self.parentOffset = offset or {0,0}
	self.parent = parent or false
	self.parentFloored = floored or false
end

function Entity:dist(other)
	return math.dist(self.pos[1],self.pos[2], other.pos[1],other.pos[2])
end

function Entity:angle(other)
	return math.angle(self.pos[1],self.pos[2], other.pos[1],other.pos[2])
end


function Entity:destroy()
	Dynamic.destroy(self)
	removeFromTable(Entity.list,self)
end

function file:init()
end

function file:update()
	for i,e in pairs(Entity.list) do
		if e.parent then
			local parentPos = e.parent.pos

			if self.parentFloored then
				parentPos = {floor(parentPos[1]),floor(parentPos[2])}
			end

			e:setPos(parentPos)
			e:move(e.parentOffset)
		end
	end
end

function file:draw()
end

-- [[ RETURN ]] --
return file