local file = {priority = 0}

Juice = {list = {}}

function Juice:new()
	local juice = Class:init(Juice,Dynamic)
	
	juice.offset = {x = 0, y = 0, z = 0}
	juice.rot = 0
	juice.scale = 1
	
	juice.shakeAmount = 0
	juice.shakeDecrease = 4
	
	juice.rotAmount = 0
	juice.rotChange = 0.3
	
	juice.scaleChange = 0.2
	
	return juice
end


function Juice:getOffset()
	return self.offset.x, self.offset.y
end

function Juice:getRotation()
	return self.rot
end

function Juice:getScale()
	return self.scale
end


function Juice:freeze(t)
	t = t or (1 / 30)
	love.timer.sleep(t)
end

function Juice:shake(amount)
	self.shakeAmount = max(self.shakeAmount,amount) or 0
end

function Juice:tilt(tilt)
	self.rotAmount = tilt or 0
end

function Juice:zoom(zoom)
	self.scale = zoom or 1
end


function Juice:updateScale()
	if self.scale > 1 then
		self.scale = max(self.scale - self.scaleChange * gdt, 1)
	end
	if self.scale < 1 then
		self.scale = min(self.scale + self.scaleChange * gdt, 1)
	end
end

function Juice:updateRotation()
	self.rotAmount = max(self.rotAmount - self.rotChange * gdt, 0)
	self.rot = math.random() * self.rotAmount * rsign()
end

function Juice:updateShake()
	self.shakeAmount = max(self.shakeAmount - self.shakeAmount * self.shakeDecrease * gdt, 0)
	
	local dir = random() * pi * 2
	
	self.offset.x = cos(dir) * self.shakeAmount
	self.offset.y = sin(dir) * self.shakeAmount
end

function Juice:update()
	self:updateScale()
	self:updateRotation()
	self:updateShake()
end


function file:init()
	Juice = Juice:new()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file