local file = {priority = 0}

Particle = {list = {}}

function Particle:new(pos,radius,color,lifespan,gravity,dir)
	local self = Class:init(Particle,Entity,{pos})

	self.color = color or {1,1,1}
	self.radius = radius or 2
	self.gravity = gravity or 0
	self.lifespan = lifespan or 1
	self.timer = 1
	self.dir = dir or {0,0}
	self.drawMode = "fill"

	table.insert(Particle.list,self)
	return self
end


function Particle:update()
	self.dir[2] = self.dir[2] + self.gravity * gdt
	self:move(self.dir[1]*gdt,self.dir[2]*gdt)
	self.timer = self.timer - gdt/self.lifespan
	if self.timer < 0 then
		self:destroy()
	end
end

function Particle:draw()
	lg.setColor(self.color[1],self.color[2],self.color[3], self.color[4] or 1)
	lg.circle(self.drawMode, self.pos[1],self.pos[2],self.radius*self.timer)
end


function Particle:destroy()
	Entity.destroy(self)
	removeFromTable(Particle.list,self)
end

function file:init()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file