local file = {priority = 11}

SacrificeHandler = {}

function SacrificeHandler:new()
	local self = Class:init(SacrificeHandler,Dynamic)

	self.projectileSpeed = 1
	self.bossTimerSpeed = 1

	self.sacrifices = {
		{
			name = "HEALTH",
			description = "Reduce your max health.",
			func = function() 
				Player.maxHealth = max(1, Player.maxHealth - 1)
				Player.health = min(Player.health, Player.maxHealth)
			end
		},
		{
			name = "STRENGTH",
			description = "Weakens your damage.",
			func = function() 
				Player.attackDamage = Player.attackDamage * 0.75
			end
		},
		{
			name = "REFLEXES",
			description = "Increase projectile speed.",
			func = function() 
				self.projectileSpeed = self.projectileSpeed + 0.5
			end
		},
		{
			name = "VIGILANCE",
			description = "Bosses become faster and more aggressive.",
			func = function() 
				self.bossTimerSpeed = self.bossTimerSpeed + 0.25
			end
		},
		{
			name = "DEXTERITY",
			description = "Increase time between attacks.",
			func = function() 
				Player.attackComboTime = Player.attackComboTime * 1.5
				Player.maxAttackTimer = Player.maxAttackTimer + 0.03
			end
		},
	}

	self.chooseList = {self.sacrifices[1],self.sacrifices[2],self.sacrifices[3]}
	self.chooseIndex = 2

	return self
end


function SacrificeHandler:selectSacrifice()
	if Controller:selectLeft() then
		self.chooseIndex = max(1, self.chooseIndex - 1)
	end
	if Controller:selectRight() then
		self.chooseIndex = min(#self.chooseList, self.chooseIndex + 1)
	end
	if Controller:select() then
		self.chooseList[self.chooseIndex].func()
		Game.state = "playing"
		self.sacrifices = shuffle(self.sacrifices)
		self.chooseList = {self.sacrifices[1],self.sacrifices[2],self.sacrifices[3]}
		Player.sacrifices = Player.sacrifices + 1
	end
end

function SacrificeHandler:update()
	if Game.state == "sacrifice" then
		self:selectSacrifice()
	end
end


function file:init()
	SacrificeHandler = SacrificeHandler:new()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file