local file = {priority = 11}

ShaderHandler = {}

function ShaderHandler:new()
	local self = Class:init(ShaderHandler,Dynamic)

	self.shadersEnabled = true

	shader_screen:send("palette", lg.newImage("assets/palettes/1.png"))
	shader_screenSmooth:send("enabled", self.shadersEnabled)
	self.screenMap = lg.newCanvas(Screen.resolution[1],Screen.resolution[2])
	self.ignoreMap = lg.newCanvas(Screen.resolution[1],Screen.resolution[2])

	return self
end


function ShaderHandler:update()
	if Input:isPressed("t") then
		self.shadersEnabled = not self.shadersEnabled
		shader_screenSmooth:send("enabled", self.shadersEnabled )
	end
end

function ShaderHandler:draw()
	local canvas_d = lg.getCanvas()
	lg.setCanvas(self.screenMap)

	lg.setColor(0,0,0)
	lg.rectangle("fill",0,0,100000,100000)
	lg.setColor(1,1,1)
	for i, s in pairs(Sprite.list) do
		if s.sx < 100 then
			s:draw()
		end
	end
	for i, p in pairs(Particle.list) do
		p:draw()
	end
	World:draw()

	lg.setCanvas(self.ignoreMap)

	lg.setColor(0,0,0)
	lg.rectangle("fill",0,0,100000,100000)
	lg.setColor(1,1,1)
	Hud:draw()
	Camera:apply()

	lg.setShader()
	lg.setCanvas(canvas_d)
	shader_screenSmooth:send("screenMap", self.screenMap)
	shader_screenSmooth:send("ignoreMap", self.ignoreMap)
end


function file:init()
	ShaderHandler = ShaderHandler:new()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file