function love.load()
	--shorthands
	lg = love.graphics
	la = love.audio
	lm = love.mouse
	lk = love.keyboard
	lf = love.filesystem
	li = love.image
	lt = love.timer
	lw = love.window
	max = math.max
	min = math.min
	rad = math.rad
	deg = math.deg
	sin = math.sin
	asin = math.asin
	cos = math.cos
	tan = math.tan
	atan = math.atan
	atan2 = math.atan2
	floor = math.floor
	ceil = math.ceil
	abs = math.abs
	random = love.math.random
	time = 0
	frame = 0
	pi = math.pi
	
	--load default assets
	lg.setLineStyle("rough")
	lg.setDefaultFilter("nearest")
	lg.setFont(lg.newImageFont("assets/font.png", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789#.,!?: ]['%/=-", 2))

	--require files
	fileHandler = require("libs.fileHandler")
	fileHandler:requireFiles("bin")
	fileHandler:requireFiles("libs")
	fileHandler:requireFiles("objects")
	fileHandler:requireFiles("shaders")
	
	lg.setCanvas()

	--start settings
	lm.setVisible(false)
	love.window.setFullscreen(true)

	-- init
	fileHandler:initScripts()
end

function love.update(dt)
	gdt = min(dt, 1 / 30)

	time = time + gdt
	frame = frame + 1
	fileHandler:updateScripts()
end

function love.draw(dt)
	Screen:apply()
	fileHandler:drawScripts()

	lg.setColor(1,1,1)
--	lg.print("FPS: "..love.timer.getFPS(),10,10)
end
