local file = {priority = 1}

Sentry = {}

function Sentry:new(pos)
	local self = Class:init(Sentry,Enemy,{pos, 4, 5})

	self.speed = 15
	self.chargeSpeed = 110
	self.flip = 1
	self.walkanim = Animation:new("assets/enemies/sentry.png",0.7)
	self.windupanim = Animation:new("assets/enemies/sentryWindup.png",0.2)
	self.winddownanim = Animation:new("assets/enemies/sentryWinddown.png",1)
	self.anim = self.walkanim
	self.timer = 0
	self.particleTimer = 0
	self.state = "walking"
	self.attackRange = 12 + Player.radius

	return self
end


function Sentry:moveAround()
	self.timer = self.timer + gdt
	self.particleTimer = self.particleTimer + gdt

	if self.state == "walking" then
		self.anim = self.walkanim
		self:move(self.speed*gdt*self.flip,0)

		local groundPos,wallPos = {self.pos[1]+self.radius*self.flip,self.pos[2]+4},{self.pos[1]+self.radius*self.flip,self.pos[2]-2}
		if not World:getCell(groundPos).solid or World:getCell(wallPos).solid then
			self.flip = -self.flip
		end

		if self.timer > 3 and math.dist(self.pos[1],self.pos[2], Player.pos[1],Player.pos[2]) < self.attackRange then
			self.flip = sign(Player.pos[1]-self.pos[1])
			self.state = "windup"
			self.timer = 0
		end
	end
	if self.state == "windup" then
		self.anim = self.windupanim

		if self.timer > 1 then
			self.timer = 0
			self.state = "winddown"
		end
	end
	if self.state == "winddown" then
		local maxTime = 0.85
		self.anim = self.winddownanim

		if self.particleTimer > 0.04 then
			self.particleTimer = 0
			local pos = {self.pos[1]+random()*rsign()*self.radius,self.pos[2]}
			Particle:new(pos,1,{1,1,1},0.4,300,{-self.flip*15*random(),-80*(1-self.timer/maxTime)})
		end

		self:move(self.chargeSpeed*gdt*self.flip * (1-self.timer/maxTime),0)

		local groundPos,wallPos = {self.pos[1]+self.radius*self.flip,self.pos[2]+4},{self.pos[1]+self.radius*self.flip,self.pos[2]-2}
		if not World:getCell(groundPos).solid or World:getCell(wallPos).solid then
			self.flip = -self.flip
			self.timer = maxTime
		end

		if self.timer > maxTime then
			self.timer = 0
			self.state = "walking"
		end
	end
end

function Sentry:update()
	Enemy.update(self)

	self:moveAround()
end


function file:init()
end

function file:update()
end

function file:draw()
end

-- [[ RETURN ]] --
return file